git-stash.shon commit Documentation/git-bisect.txt: git bisect term → git bisect terms (bbd374d)
   1#!/bin/sh
   2# Copyright (c) 2007, Nanako Shiraishi
   3
   4dashless=$(basename "$0" | sed -e 's/-/ /')
   5USAGE="list [<options>]
   6   or: $dashless show [<stash>]
   7   or: $dashless drop [-q|--quiet] [<stash>]
   8   or: $dashless ( pop | apply ) [--index] [-q|--quiet] [<stash>]
   9   or: $dashless branch <branchname> [<stash>]
  10   or: $dashless [save [--patch] [-k|--[no-]keep-index] [-q|--quiet]
  11                       [-u|--include-untracked] [-a|--all] [<message>]]
  12   or: $dashless clear"
  13
  14SUBDIRECTORY_OK=Yes
  15OPTIONS_SPEC=
  16START_DIR=$(pwd)
  17. git-sh-setup
  18. git-sh-i18n
  19require_work_tree
  20cd_to_toplevel
  21
  22TMP="$GIT_DIR/.git-stash.$$"
  23TMPindex=${GIT_INDEX_FILE-"$(git rev-parse --git-path index)"}.stash.$$
  24trap 'rm -f "$TMP-"* "$TMPindex"' 0
  25
  26ref_stash=refs/stash
  27
  28if git config --get-colorbool color.interactive; then
  29       help_color="$(git config --get-color color.interactive.help 'red bold')"
  30       reset_color="$(git config --get-color '' reset)"
  31else
  32       help_color=
  33       reset_color=
  34fi
  35
  36no_changes () {
  37        git diff-index --quiet --cached HEAD --ignore-submodules -- &&
  38        git diff-files --quiet --ignore-submodules &&
  39        (test -z "$untracked" || test -z "$(untracked_files)")
  40}
  41
  42untracked_files () {
  43        excl_opt=--exclude-standard
  44        test "$untracked" = "all" && excl_opt=
  45        git ls-files -o -z $excl_opt
  46}
  47
  48clear_stash () {
  49        if test $# != 0
  50        then
  51                die "$(gettext "git stash clear with parameters is unimplemented")"
  52        fi
  53        if current=$(git rev-parse --verify --quiet $ref_stash)
  54        then
  55                git update-ref -d $ref_stash $current
  56        fi
  57}
  58
  59create_stash () {
  60        stash_msg="$1"
  61        untracked="$2"
  62
  63        git update-index -q --refresh
  64        if no_changes
  65        then
  66                exit 0
  67        fi
  68
  69        # state of the base commit
  70        if b_commit=$(git rev-parse --verify HEAD)
  71        then
  72                head=$(git rev-list --oneline -n 1 HEAD --)
  73        else
  74                die "$(gettext "You do not have the initial commit yet")"
  75        fi
  76
  77        if branch=$(git symbolic-ref -q HEAD)
  78        then
  79                branch=${branch#refs/heads/}
  80        else
  81                branch='(no branch)'
  82        fi
  83        msg=$(printf '%s: %s' "$branch" "$head")
  84
  85        # state of the index
  86        i_tree=$(git write-tree) &&
  87        i_commit=$(printf 'index on %s\n' "$msg" |
  88                git commit-tree $i_tree -p $b_commit) ||
  89                die "$(gettext "Cannot save the current index state")"
  90
  91        if test -n "$untracked"
  92        then
  93                # Untracked files are stored by themselves in a parentless commit, for
  94                # ease of unpacking later.
  95                u_commit=$(
  96                        untracked_files | (
  97                                GIT_INDEX_FILE="$TMPindex" &&
  98                                export GIT_INDEX_FILE &&
  99                                rm -f "$TMPindex" &&
 100                                git update-index -z --add --remove --stdin &&
 101                                u_tree=$(git write-tree) &&
 102                                printf 'untracked files on %s\n' "$msg" | git commit-tree $u_tree  &&
 103                                rm -f "$TMPindex"
 104                ) ) || die "Cannot save the untracked files"
 105
 106                untracked_commit_option="-p $u_commit";
 107        else
 108                untracked_commit_option=
 109        fi
 110
 111        if test -z "$patch_mode"
 112        then
 113
 114                # state of the working tree
 115                w_tree=$( (
 116                        git read-tree --index-output="$TMPindex" -m $i_tree &&
 117                        GIT_INDEX_FILE="$TMPindex" &&
 118                        export GIT_INDEX_FILE &&
 119                        git diff --name-only -z HEAD -- >"$TMP-stagenames" &&
 120                        git update-index -z --add --remove --stdin <"$TMP-stagenames" &&
 121                        git write-tree &&
 122                        rm -f "$TMPindex"
 123                ) ) ||
 124                        die "$(gettext "Cannot save the current worktree state")"
 125
 126        else
 127
 128                rm -f "$TMP-index" &&
 129                GIT_INDEX_FILE="$TMP-index" git read-tree HEAD &&
 130
 131                # find out what the user wants
 132                GIT_INDEX_FILE="$TMP-index" \
 133                        git add--interactive --patch=stash -- &&
 134
 135                # state of the working tree
 136                w_tree=$(GIT_INDEX_FILE="$TMP-index" git write-tree) ||
 137                die "$(gettext "Cannot save the current worktree state")"
 138
 139                git diff-tree -p HEAD $w_tree -- >"$TMP-patch" &&
 140                test -s "$TMP-patch" ||
 141                die "$(gettext "No changes selected")"
 142
 143                rm -f "$TMP-index" ||
 144                die "$(gettext "Cannot remove temporary index (can't happen)")"
 145
 146        fi
 147
 148        # create the stash
 149        if test -z "$stash_msg"
 150        then
 151                stash_msg=$(printf 'WIP on %s' "$msg")
 152        else
 153                stash_msg=$(printf 'On %s: %s' "$branch" "$stash_msg")
 154        fi
 155        w_commit=$(printf '%s\n' "$stash_msg" |
 156        git commit-tree $w_tree -p $b_commit -p $i_commit $untracked_commit_option) ||
 157        die "$(gettext "Cannot record working tree state")"
 158}
 159
 160store_stash () {
 161        while test $# != 0
 162        do
 163                case "$1" in
 164                -m|--message)
 165                        shift
 166                        stash_msg="$1"
 167                        ;;
 168                -q|--quiet)
 169                        quiet=t
 170                        ;;
 171                *)
 172                        break
 173                        ;;
 174                esac
 175                shift
 176        done
 177        test $# = 1 ||
 178        die "$(eval_gettext "\"$dashless store\" requires one <commit> argument")"
 179
 180        w_commit="$1"
 181        if test -z "$stash_msg"
 182        then
 183                stash_msg="Created via \"git stash store\"."
 184        fi
 185
 186        # Make sure the reflog for stash is kept.
 187        : >>"$(git rev-parse --git-path logs/$ref_stash)"
 188        git update-ref -m "$stash_msg" $ref_stash $w_commit
 189        ret=$?
 190        test $ret != 0 && test -z $quiet &&
 191        die "$(eval_gettext "Cannot update \$ref_stash with \$w_commit")"
 192        return $ret
 193}
 194
 195save_stash () {
 196        keep_index=
 197        patch_mode=
 198        untracked=
 199        while test $# != 0
 200        do
 201                case "$1" in
 202                -k|--keep-index)
 203                        keep_index=t
 204                        ;;
 205                --no-keep-index)
 206                        keep_index=n
 207                        ;;
 208                -p|--patch)
 209                        patch_mode=t
 210                        # only default to keep if we don't already have an override
 211                        test -z "$keep_index" && keep_index=t
 212                        ;;
 213                -q|--quiet)
 214                        GIT_QUIET=t
 215                        ;;
 216                -u|--include-untracked)
 217                        untracked=untracked
 218                        ;;
 219                -a|--all)
 220                        untracked=all
 221                        ;;
 222                --help)
 223                        show_help
 224                        ;;
 225                --)
 226                        shift
 227                        break
 228                        ;;
 229                -*)
 230                        option="$1"
 231                        # TRANSLATORS: $option is an invalid option, like
 232                        # `--blah-blah'. The 7 spaces at the beginning of the
 233                        # second line correspond to "error: ". So you should line
 234                        # up the second line with however many characters the
 235                        # translation of "error: " takes in your language. E.g. in
 236                        # English this is:
 237                        #
 238                        #    $ git stash save --blah-blah 2>&1 | head -n 2
 239                        #    error: unknown option for 'stash save': --blah-blah
 240                        #           To provide a message, use git stash save -- '--blah-blah'
 241                        eval_gettextln "error: unknown option for 'stash save': \$option
 242       To provide a message, use git stash save -- '\$option'"
 243                        usage
 244                        ;;
 245                *)
 246                        break
 247                        ;;
 248                esac
 249                shift
 250        done
 251
 252        if test -n "$patch_mode" && test -n "$untracked"
 253        then
 254            die "Can't use --patch and --include-untracked or --all at the same time"
 255        fi
 256
 257        stash_msg="$*"
 258
 259        git update-index -q --refresh
 260        if no_changes
 261        then
 262                say "$(gettext "No local changes to save")"
 263                exit 0
 264        fi
 265        test -f "$(git rev-parse --git-path logs/$ref_stash)" ||
 266                clear_stash || die "$(gettext "Cannot initialize stash")"
 267
 268        create_stash "$stash_msg" $untracked
 269        store_stash -m "$stash_msg" -q $w_commit ||
 270        die "$(gettext "Cannot save the current status")"
 271        say Saved working directory and index state "$stash_msg"
 272
 273        if test -z "$patch_mode"
 274        then
 275                git reset --hard ${GIT_QUIET:+-q}
 276                test "$untracked" = "all" && CLEAN_X_OPTION=-x || CLEAN_X_OPTION=
 277                if test -n "$untracked"
 278                then
 279                        git clean --force --quiet -d $CLEAN_X_OPTION
 280                fi
 281
 282                if test "$keep_index" = "t" && test -n $i_tree
 283                then
 284                        git read-tree --reset -u $i_tree
 285                fi
 286        else
 287                git apply -R < "$TMP-patch" ||
 288                die "$(gettext "Cannot remove worktree changes")"
 289
 290                if test "$keep_index" != "t"
 291                then
 292                        git reset
 293                fi
 294        fi
 295}
 296
 297have_stash () {
 298        git rev-parse --verify --quiet $ref_stash >/dev/null
 299}
 300
 301list_stash () {
 302        have_stash || return 0
 303        git log --format="%gd: %gs" -g --first-parent -m "$@" $ref_stash --
 304}
 305
 306show_stash () {
 307        ALLOW_UNKNOWN_FLAGS=t
 308        assert_stash_like "$@"
 309
 310        git diff ${FLAGS:---stat} $b_commit $w_commit
 311}
 312
 313show_help () {
 314        exec git help stash
 315        exit 1
 316}
 317
 318#
 319# Parses the remaining options looking for flags and
 320# at most one revision defaulting to ${ref_stash}@{0}
 321# if none found.
 322#
 323# Derives related tree and commit objects from the
 324# revision, if one is found.
 325#
 326# stash records the work tree, and is a merge between the
 327# base commit (first parent) and the index tree (second parent).
 328#
 329#   REV is set to the symbolic version of the specified stash-like commit
 330#   IS_STASH_LIKE is non-blank if ${REV} looks like a stash
 331#   IS_STASH_REF is non-blank if the ${REV} looks like a stash ref
 332#   s is set to the SHA1 of the stash commit
 333#   w_commit is set to the commit containing the working tree
 334#   b_commit is set to the base commit
 335#   i_commit is set to the commit containing the index tree
 336#   u_commit is set to the commit containing the untracked files tree
 337#   w_tree is set to the working tree
 338#   b_tree is set to the base tree
 339#   i_tree is set to the index tree
 340#   u_tree is set to the untracked files tree
 341#
 342#   GIT_QUIET is set to t if -q is specified
 343#   INDEX_OPTION is set to --index if --index is specified.
 344#   FLAGS is set to the remaining flags (if allowed)
 345#
 346# dies if:
 347#   * too many revisions specified
 348#   * no revision is specified and there is no stash stack
 349#   * a revision is specified which cannot be resolve to a SHA1
 350#   * a non-existent stash reference is specified
 351#   * unknown flags were set and ALLOW_UNKNOWN_FLAGS is not "t"
 352#
 353
 354parse_flags_and_rev()
 355{
 356        test "$PARSE_CACHE" = "$*" && return 0 # optimisation
 357        PARSE_CACHE="$*"
 358
 359        IS_STASH_LIKE=
 360        IS_STASH_REF=
 361        INDEX_OPTION=
 362        s=
 363        w_commit=
 364        b_commit=
 365        i_commit=
 366        u_commit=
 367        w_tree=
 368        b_tree=
 369        i_tree=
 370        u_tree=
 371
 372        REV=$(git rev-parse --no-flags --symbolic --sq "$@") || exit 1
 373
 374        FLAGS=
 375        for opt
 376        do
 377                case "$opt" in
 378                        -q|--quiet)
 379                                GIT_QUIET=-t
 380                        ;;
 381                        --index)
 382                                INDEX_OPTION=--index
 383                        ;;
 384                        --help)
 385                                show_help
 386                        ;;
 387                        -*)
 388                                test "$ALLOW_UNKNOWN_FLAGS" = t ||
 389                                        die "$(eval_gettext "unknown option: \$opt")"
 390                                FLAGS="${FLAGS}${FLAGS:+ }$opt"
 391                        ;;
 392                esac
 393        done
 394
 395        eval set -- $REV
 396
 397        case $# in
 398                0)
 399                        have_stash || die "$(gettext "No stash found.")"
 400                        set -- ${ref_stash}@{0}
 401                ;;
 402                1)
 403                        :
 404                ;;
 405                *)
 406                        die "$(eval_gettext "Too many revisions specified: \$REV")"
 407                ;;
 408        esac
 409
 410        REV=$(git rev-parse --symbolic --verify --quiet "$1") || {
 411                reference="$1"
 412                die "$(eval_gettext "\$reference is not a valid reference")"
 413        }
 414
 415        i_commit=$(git rev-parse --verify --quiet "$REV^2") &&
 416        set -- $(git rev-parse "$REV" "$REV^1" "$REV:" "$REV^1:" "$REV^2:" 2>/dev/null) &&
 417        s=$1 &&
 418        w_commit=$1 &&
 419        b_commit=$2 &&
 420        w_tree=$3 &&
 421        b_tree=$4 &&
 422        i_tree=$5 &&
 423        IS_STASH_LIKE=t &&
 424        test "$ref_stash" = "$(git rev-parse --symbolic-full-name "${REV%@*}")" &&
 425        IS_STASH_REF=t
 426
 427        u_commit=$(git rev-parse --verify --quiet "$REV^3") &&
 428        u_tree=$(git rev-parse "$REV^3:" 2>/dev/null)
 429}
 430
 431is_stash_like()
 432{
 433        parse_flags_and_rev "$@"
 434        test -n "$IS_STASH_LIKE"
 435}
 436
 437assert_stash_like() {
 438        is_stash_like "$@" || {
 439                args="$*"
 440                die "$(eval_gettext "'\$args' is not a stash-like commit")"
 441        }
 442}
 443
 444is_stash_ref() {
 445        is_stash_like "$@" && test -n "$IS_STASH_REF"
 446}
 447
 448assert_stash_ref() {
 449        is_stash_ref "$@" || {
 450                args="$*"
 451                die "$(eval_gettext "'\$args' is not a stash reference")"
 452        }
 453}
 454
 455apply_stash () {
 456
 457        assert_stash_like "$@"
 458
 459        git update-index -q --refresh || die "$(gettext "unable to refresh index")"
 460        git diff-index --cached --quiet --ignore-submodules HEAD -- ||
 461                die "$(gettext "Cannot apply stash: Your index contains uncommitted changes.")"
 462
 463        # current index state
 464        c_tree=$(git write-tree) ||
 465                die "$(gettext "Cannot apply a stash in the middle of a merge")"
 466
 467        unstashed_index_tree=
 468        if test -n "$INDEX_OPTION" && test "$b_tree" != "$i_tree" &&
 469                        test "$c_tree" != "$i_tree"
 470        then
 471                git diff-tree --binary $s^2^..$s^2 | git apply --cached
 472                test $? -ne 0 &&
 473                        die "$(gettext "Conflicts in index. Try without --index.")"
 474                unstashed_index_tree=$(git write-tree) ||
 475                        die "$(gettext "Could not save index tree")"
 476                git reset
 477        fi
 478
 479        if test -n "$u_tree"
 480        then
 481                GIT_INDEX_FILE="$TMPindex" git-read-tree "$u_tree" &&
 482                GIT_INDEX_FILE="$TMPindex" git checkout-index --all &&
 483                rm -f "$TMPindex" ||
 484                die 'Could not restore untracked files from stash'
 485        fi
 486
 487        eval "
 488                GITHEAD_$w_tree='Stashed changes' &&
 489                GITHEAD_$c_tree='Updated upstream' &&
 490                GITHEAD_$b_tree='Version stash was based on' &&
 491                export GITHEAD_$w_tree GITHEAD_$c_tree GITHEAD_$b_tree
 492        "
 493
 494        if test -n "$GIT_QUIET"
 495        then
 496                GIT_MERGE_VERBOSITY=0 && export GIT_MERGE_VERBOSITY
 497        fi
 498        if git merge-recursive $b_tree -- $c_tree $w_tree
 499        then
 500                # No conflict
 501                if test -n "$unstashed_index_tree"
 502                then
 503                        git read-tree "$unstashed_index_tree"
 504                else
 505                        a="$TMP-added" &&
 506                        git diff-index --cached --name-only --diff-filter=A $c_tree >"$a" &&
 507                        git read-tree --reset $c_tree &&
 508                        git update-index --add --stdin <"$a" ||
 509                                die "$(gettext "Cannot unstage modified files")"
 510                        rm -f "$a"
 511                fi
 512                squelch=
 513                if test -n "$GIT_QUIET"
 514                then
 515                        squelch='>/dev/null 2>&1'
 516                fi
 517                (cd "$START_DIR" && eval "git status $squelch") || :
 518        else
 519                # Merge conflict; keep the exit status from merge-recursive
 520                status=$?
 521                git rerere
 522                if test -n "$INDEX_OPTION"
 523                then
 524                        gettextln "Index was not unstashed." >&2
 525                fi
 526                exit $status
 527        fi
 528}
 529
 530pop_stash() {
 531        assert_stash_ref "$@"
 532
 533        if apply_stash "$@"
 534        then
 535                drop_stash "$@"
 536        else
 537                status=$?
 538                say "The stash is kept in case you need it again."
 539                exit $status
 540        fi
 541}
 542
 543drop_stash () {
 544        assert_stash_ref "$@"
 545
 546        git reflog delete --updateref --rewrite "${REV}" &&
 547                say "$(eval_gettext "Dropped \${REV} (\$s)")" ||
 548                die "$(eval_gettext "\${REV}: Could not drop stash entry")"
 549
 550        # clear_stash if we just dropped the last stash entry
 551        git rev-parse --verify --quiet "$ref_stash@{0}" >/dev/null ||
 552        clear_stash
 553}
 554
 555apply_to_branch () {
 556        test -n "$1" || die "$(gettext "No branch name specified")"
 557        branch=$1
 558        shift 1
 559
 560        set -- --index "$@"
 561        assert_stash_like "$@"
 562
 563        git checkout -b $branch $REV^ &&
 564        apply_stash "$@" && {
 565                test -z "$IS_STASH_REF" || drop_stash "$@"
 566        }
 567}
 568
 569PARSE_CACHE='--not-parsed'
 570# The default command is "save" if nothing but options are given
 571seen_non_option=
 572for opt
 573do
 574        case "$opt" in
 575        -*) ;;
 576        *) seen_non_option=t; break ;;
 577        esac
 578done
 579
 580test -n "$seen_non_option" || set "save" "$@"
 581
 582# Main command set
 583case "$1" in
 584list)
 585        shift
 586        list_stash "$@"
 587        ;;
 588show)
 589        shift
 590        show_stash "$@"
 591        ;;
 592save)
 593        shift
 594        save_stash "$@"
 595        ;;
 596apply)
 597        shift
 598        apply_stash "$@"
 599        ;;
 600clear)
 601        shift
 602        clear_stash "$@"
 603        ;;
 604create)
 605        shift
 606        create_stash "$*" && echo "$w_commit"
 607        ;;
 608store)
 609        shift
 610        store_stash "$@"
 611        ;;
 612drop)
 613        shift
 614        drop_stash "$@"
 615        ;;
 616pop)
 617        shift
 618        pop_stash "$@"
 619        ;;
 620branch)
 621        shift
 622        apply_to_branch "$@"
 623        ;;
 624*)
 625        case $# in
 626        0)
 627                save_stash &&
 628                say "$(gettext "(To restore them type \"git stash apply\")")"
 629                ;;
 630        *)
 631                usage
 632        esac
 633        ;;
 634esac